<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
  	<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
  	<title>Doozer - Index</title>
  	<style>
      BODY { font-family: "Segoe UI", "Gill Sans", Optima, Helvetica, Tahoma, Arial, Sans-Serif; font-size: 15px; padding: 20px 100px; }
  	  P, TD, LI, PRE, CODE { color: gray; }
  	  PRE { background-color: #F0F0F0; padding: 15px; }
  	  #header * { margin: 0; padding: 0; }
  	  #header h1 { color: navy; }
  	  #navigation { margin-top: 15px; background: #E0E0E0; padding: 5px 15px; font-weight: bolder; text-align: center; }
  	  #navigation A, #navigation SPAN { margin-right: 20px; text-shadow: 3px 3px 4px #999; }
  	  #navigation A { color: black; }
  	  #navigation A:hover { color: navy; }
  	  #navigation SPAN { color: white; }
  	  #content A { color: navy; }
  	  #content A:hover { color: blue; }
  	  #footer { margin: 15px 0px; }
  	  #footer A { color: gray; }
  	  #footer #info { color: gray; float:right; }
  	</style>
  </head>
  <body>
    <div id="container">
      <div id="header">
        <h1>Doozer</h1>
        <h4>Simple Fixture Generator</h4>
      </div>
      <div id="navigation">
        
          
            <a href="example.html">Example</a>
          
        
          
            <a href="fixture-comparison.html">Fixture Comparison</a>
          
        
          
            <span>Index</span>
          
        
          
            <a href="test-specs.html">Test Specs</a>
          
        
      </div>
      <div id="content">
        <p><strong>Doozer</strong> is a simple fixture generation library/plugin that handles all the annoying id management, and association building, allowing you to focus on crafting meaningful test fixtures.</p>

<h3>Installation</h3>

<p>In your rails project directory, run:</p>

<pre><code>./script/plugin source http://mattmccray.com/svn/rails/plugins/
./script/plugin install doozer
</code></pre>

<h3>Usage</h3>

<p>Doozer scripts are usually ruby files that live in the <code>RAILS_ROOT/text/fixtures/doozers</code> directory. </p>

<p>Let's walk through a simple <code>pages.rb</code> doozer. At the top of the script, we'll add this:</p>

<pre><code>Doozer.define :page do
  field_order :title, :content, :author

  defaults :content=&gt;'Content Here',
           :author=&gt;'System', 
           :created_on=&gt;Time.now.to_s(:db)

  block_affects :child=&gt;:parent_id
end
</code></pre>

<p>That tells Doozer that you are going to generate <code>page</code> fixtures. It then generates three macros for you to use: <code>page</code>, <code>page_id</code>, and <code>pages</code>. The first macro is the one you'll use most. It defines, or updates, fixture data. </p>

<p>In the definition block, it maps positional parameters to the fixture data fields. It sets up some default values for the fixture data. And lastly, configures how to handle fixtures defined in a <code>page</code> macro block.</p>

<p>Now we can start to write our test data like this:</p>

<pre><code>page :root, "Home Page" do
  page :news, "News is always Fun!" do
    page :site_launch, "Site launched!", :created_on=&gt;1.week.ago
    page :more_news, "More news", :created_on=&gt;3.days.ago
  end
end
</code></pre>

<p>There are a couple of things to go over here... </p>

<p>First, you'll notice the first parameter sent to the <code>page</code> macro is a symbol, it's used as the fixture name. It's optional, if you don't specify a name one will be automatically generated. </p>

<p>We also are mixing positional parameters and named parameters. We specify the <code>field_order</code> of the positional parameters, any named parameters are sent straight to the fixture data whether it's defined in the <code>field_order</code> or not.</p>

<p>So here's a breakdown of an example <code>page</code> macro call:</p>

<pre><code>page :site_launch,   "Site launched!",   :created_on=&gt;1.week.ago    
     ^ fixture name  ^ field_order[0]    ^ sent straight to the
                       :title              fixture data
</code></pre>

<p>It will have handled the relationships automatically, as well. Since the <code>:site_launch</code> fixture is defined in a block under <code>:news</code>, the <code>:site_launch</code> fixture will have the appropriate <code>:parent_id</code> set.</p>

<p>In the definition above, we used <code>block_affects :child=&gt;:parent_id</code> to handle our <code>acts_as_tree</code> example. Other options include <code>:child=&gt;:belongs_to</code> and <code>:parent=&gt;:belongs_to</code>, with more to come.</p>

<p>It's worth noting here that you can reference the same fixture multiple times, each time it will add to the fixture data it's associated with. So you can create partial fixtures and complete them elsewhere in the doozer script. </p>

<p>In our example so far, all of the pages will have the default content of "Content Here" (as defined in the <code>defaults</code> hash). Let's change that by calling the <code>page</code> macro again with fixture name and the content attribute. Since the content field isn't the first defined in the <code>field_order</code> we'll use a named parameter.</p>

<p>These lines go at the bottom of the definition file:</p>

<pre><code>page :root,        :content=&gt;&lt;&lt;-EOC
Welcome to this this site, please enjoy yourself!

Multiple lines are good too.
EOC

page :news,        :content=&gt;"I'm the parent page to all of the news!"
page :site_launch, :content=&gt;"Really, it was!"
page :more_news,   :content=&gt;"No Gnus is Good Gnus!"
</code></pre>

<p>That's the basics of a doozer script. To generate the fixture(s), just run:</p>

<pre><code>rake doozer:build
</code></pre>

<p>Here's the generated fixture from our example above:</p>

<pre><code>root: 
  created_on: 2007-03-20 15:21:47
  title: Home Page
  author: System
  id: 1
  content: |
    Welcome to this this site, please enjoy yourself!

    Multiple lines are good too.

news: 
  created_on: 2007-03-20 15:21:47
  title: News is always Fun!
  author: System
  id: 2
  content: I'm the parent page to all of the news!
  parent_id: 1

site_launch: 
  created_on: 2007-03-13 15:21:47.096033 -05:00
  title: Site launched!
  author: System
  id: 3
  content: Really, it was!
  parent_id: 2

more_news: 
  created_on: 2007-03-17 15:21:47.096100 -05:00
  title: More news
  author: System
  id: 4
  content: No Gnus is Good Gnus!
  parent_id: 2
</code></pre>

<p>That's it, enjoy!</p>
      </div>
      <div id="footer">
        <div id="info">
          Created by <a href="http://www.mattmccray.com">M@ McCray</a>
        </div>
        <a href="#">^ back to the top</a>
      </div>
    </div>
  </body>
</html>


